	.686
	.model flat, stdcall
	option casemap :none

	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

.code
KTRAP_FRAME struct
DbgEbp		ULONG ?	; +0
DbgEip		ULONG ?	; +4
DbgArgMark	ULONG ?	; +8
DbgArgPointer	ULONG ?	; +C

TempCs		ULONG ?	; +10
TempEsp		ULONG ?	; +14

rDr0			ULONG ?	; +18
rDr1			ULONG ?	; +1C
rDr2			ULONG ?	; +20
rDr3			ULONG ?	; +24
rDr6			ULONG ?	; +28
rDr7			ULONG ?	; +2C

rGs			ULONG ?	; +30
rEs			ULONG ?	; +34
rDs			ULONG ?	; +38

rEdx			ULONG ?	; +3C
rEcx			ULONG ?	; +40
rEax			ULONG ?	; +44

PreviousPreviousMode	ULONG ?	; +48

ExceptionList	PVOID ?	; +4C

rFs			ULONG ?	; +50

rEdi			ULONG ?	; +54
rEsi			ULONG ?	; +58
rEbx			ULONG ?	; +5C
rEbp			ULONG ?	; +60

ErrCode		ULONG ?	; +64
rEip			ULONG ?	; +68
rCs			ULONG ?	; +6C
rEFlags		ULONG ?	; +70

; WARNING - Ss:Esp are only here for stacks that involve a ring transition.
HardwareEsp	ULONG ?	; +74
HardwareSegSs	ULONG ?	; +78

V86Es		ULONG ?
V86Ds		ULONG ?
V86Fs		ULONG ?
V86Gs		ULONG ?
KTRAP_FRAME ends
PKTRAP_FRAME typedef ptr KTRAP_FRAME

; - SIDE -
SIDE_NTCALL	equ 0BADC0DEH
SIDE_BACKDOOR	equ SIDE_NTCALL + 1

PEB_FLT			equ D(X86_PAGE_SIZE - 4)	;      PEB.

TEB_FLT			equ D(X86_PAGE_SIZE - 4)	;    TEB.

; .
TEB_OPT_NT		equ 0001B	; IN,    .
TEB_OPT_NT_BIT		equ 0
TEB_OPT_TSC		equ 0010B	; IN,     .
TEB_OPT_TSC_BIT	equ 1

TEB_OPT_MASK		equ TEB_OPT_NT or TEB_OPT_TSC	;   .

; .
TEB_FLG_NT		equ 0100B	; OUT, TF    .
TEB_FLG_NT_BIT		equ 2
TEB_FLG_TSC		equ 1000B	; OUT, TF   RDTSC.
TEB_FLG_TSC_BIT	equ 3

	assume fs:nothing
;    .
%FENTER macro
	push fs:[TEB_FLT]
	or fs:[TEB_FLT],TEB_OPT_MASK
endm

;   .
%FLEAVE macro
	xchg D[esp],eax
	and fs:[TEB_FLT],NOT(TEB_OPT_MASK)
	and eax,TEB_OPT_MASK
	or fs:[TEB_FLT],eax
	pop eax
endm

;     .
FSTATE struct
	Ip	PVOID ?
	Args	PVOID ?
FSTATE ends
PFSTATE typedef ptr FSTATE

;  .
%FSTART macro
	and fs:[TEB_FLT],NOT(TEB_OPT_MASK)
endm

;  .
%FSTOP macro
	or fs:[TEB_FLT],TEB_OPT_MASK
endm

;  TF.
%TFIX macro
	bt fs:[TEB_FLT],TEB_FLG_NT_BIT
	.if Carry?
		bts D[esp],8	; EFLAGS_TF
	.endif
endm

SHENV struct
Prolog	PVOID ?
Epilog	PVOID ?
SHENV ends

;    .
;
BACKDOOR struct
Kbase					PVOID ?	;  .
pMmGetSystemRoutineAddress	PVOID ?	; MmGetSystemRoutineAddress(Name:PUNICODE_STRING)
S						SHENV <>	;    -.
Senter					PVOID ?	; * -//-
Sip						PVOID ?	; * -//-
pMmCopy					PVOID ?	; @MmCopy
; (Src:PVOID, Dst:PVOID, S1ze:ULONG, S:PSHENV, Sip:PVOID)
Lde						PVOID ?	; @LDE(Ip:PVOID)
Kframe					PKTRAP_FRAME ?	; Kmode .
Uframe					PKTRAP_FRAME ?	; Umode (Kframe.DbgEbp).
BACKDOOR ends
PBACKDOOR typedef ptr BACKDOOR

;    .
;
UBUFFER struct
Tag		ULONG ?	; .
Address	PVOID ?	;   .
S1ze		ULONG ?	;  .
_Type	ULONG ?	;  (paged/nonpaged).
Args		PVOID ?
UBUFFER ends
PUBUFFER typedef ptr UBUFFER

.data
Arg1		ULONG ?

.code
C1:

;      .
;
; o !CPL, !IRQL, IF.
;
TestCode proc Env:PBACKDOOR, Kframe:PKTRAP_FRAME, Kcontext:PCONTEXT, Uframe:PKTRAP_FRAME, Args:PVOID
	mov eax,123456H
	ret
TestCode endp
C2:

; .
;
Filter proc C
;   FSTATE{}.
	%FENTER
	nop
	%FLEAVE
	mov edx,SIDE_NTCALL
	Int 2Eh
Filter endp

EP proc
;  .
	mov eax,fs:[TEB.Peb]
	mov D[eax + PEB_FLT],offset Filter	;  .
;  UBUFFER{}.
	push offset Arg1
	push PagedPool	;  .
	push D(offset C2 - offset C1)	;  .
	push offset C1	;  .
	push "Test"	; .         .    .
	xor eax,eax	;      ,  KDR   .
	mov edx,SIDE_BACKDOOR	; .
	Int 2Eh
	nop	; rEax: TestCode()
	nop
	%FENTER	;  .
	ret
EP endp
end EP