	.686
	.model flat, stdcall
	option casemap :none

	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib
.code
CsrGetProcessId proto

$Image	CHAR "%wZ", 13, 10, 0

	assume fs:nothing
EP proc
Local Privilege:ULONG
local Csr:HANDLE, Dbg:HANDLE
Local S1ze:ULONG
Local Base:PVOID
Local Buffer[sizeof(SYSTEM_HANDLE_INFORMATION)]:BYTE
Local N:ULONG
Local Image[MAX_PATH]:WCHAR
	invoke RtlAdjustPrivilege, SE_DEBUG_PRIVILEGE, TRUE, FALSE, addr Privilege
	invoke CsrGetProcessId
; *   .
	invoke OpenProcess, PROCESS_QUERY_INFORMATION or PROCESS_DUP_HANDLE, NULL, Eax
	mov Csr,eax
	.if Eax
		;    ,    
		;    .  .     .
		invoke ZwQuerySystemInformation, SystemHandleInformation, addr Buffer, sizeof(SYSTEM_HANDLE_INFORMATION), addr S1ze
		add S1ze,sizeof(SYSTEM_HANDLE_INFORMATION)*100
		mov Base,NULL
		invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_READWRITE
		.if !Eax
			invoke ZwQuerySystemInformation, SystemHandleInformation, Base, S1ze, NULL
			.if !Eax
				mov esi,Base
				mov ebx,Csr
				mov edi,SYSTEM_HANDLE_INFORMATION.NumberOfHandles[esi]	; N
				mov eax,fs:[TEB.Cid.UniqueProcess]
				add esi,SYSTEM_HANDLE_INFORMATION.Handles
				assume esi:PSYSTEM_HANDLE_TABLE_ENTRY_INFO
				.repeat
					.if ([Esi].UniqueProcessId == Ax) && ([Esi].HandleValue == Bx)
						movzx ebx,[esi].ObjectTypeIndex	; Process type index.
						;          .
						mov esi,Base
						mov edi,SYSTEM_HANDLE_INFORMATION.NumberOfHandles[esi]
						invoke CsrGetProcessId
						mov N,edi
						add esi,SYSTEM_HANDLE_INFORMATION.Handles
						.repeat
							.if ([Esi].UniqueProcessId == Ax) && ([Esi].ObjectTypeIndex == Bl)
								movzx edi,[esi].HandleValue
								;      .  
								;    ,      .
								invoke DuplicateHandle, Csr, Edi, NtCurrentProcess, addr Dbg, NULL, FALSE, DUPLICATE_SAME_ACCESS
								.if Eax
									invoke ZwQueryInformationProcess, Dbg, ProcessImageFileName, addr Image, MAX_PATH*2, addr S1ze
									.if !Eax
										invoke DbgPrint, addr $Image, addr Image
									.endif
								.endif
								invoke CsrGetProcessId
							.endif
							add esi,sizeof(SYSTEM_HANDLE_TABLE_ENTRY_INFO)
							dec edi
						.until Zero?
						jmp Exit
					.endif
					add esi,sizeof(SYSTEM_HANDLE_TABLE_ENTRY_INFO)
					dec edi
				.until Zero?
			.endif
			invoke ZwFreeVirtualMemory, NtCurrentProcess, addr Base, addr S1ze, MEM_RELEASE
		.endif
		invoke CloseHandle, Csr
	.endif
Exit:
	ret
EP endp
end EP